#include <Arduino.h>

//pinout main board
#define COM_RX      0
#define COM_TX      1
#define X_AXIS_M    2 //X-
#define X_AXIS_P    4 //X+
#define Y_AXIS_M    5 //Y-
#define Y_AXIS_P    3 //Y+
#define Z_AXIS_M    13 //Z- (SCK)
#define Z_AXIS_P    A3 //Z+ A3/17
#define LED_STATUS  9
#define LED_POWER   10
#define POT1        A0
#define POT2        A1

//commands
#define XP  '0' //X+ Plus
#define XM  '1' //X- Minus
#define YP  '2' //Y+
#define YM  '3' //Y-
#define ZP  '4' //Z+
#define ZM  '5' //Y-


void setup() 
{
    pinMode(X_AXIS_M, INPUT);
    pinMode(X_AXIS_P, INPUT);
    pinMode(Y_AXIS_M, INPUT);
    pinMode(Y_AXIS_P, INPUT);
    pinMode(Z_AXIS_M, INPUT);
    pinMode(Z_AXIS_P, INPUT);
    pinMode(LED_POWER, OUTPUT);
    pinMode(LED_STATUS, OUTPUT);
    pinMode(COM_TX, OUTPUT);
    pinMode(COM_RX, INPUT);
    Serial.begin(9600);
    digitalWrite(LED_POWER, HIGH);
    pinMode(COM_TX, INPUT); //configures tx as input so the communication bus is open and other nodes can connect
}

void loop() 
{
    if (digitalRead(X_AXIS_P))
    {
        //X+
        pinMode(COM_TX, OUTPUT);
        Serial.print(XP);
        Serial.flush();
        pinMode(COM_TX, INPUT);
    }
    
    if (digitalRead(X_AXIS_M))
    {
        //X-
        pinMode(COM_TX, OUTPUT);
        Serial.print(XM);
        Serial.flush();
        pinMode(COM_TX, INPUT);
    }
    
    if (digitalRead(Y_AXIS_P))
    {
        //Y+
        pinMode(COM_TX, OUTPUT);
        Serial.print(YP);
        Serial.flush();
        pinMode(COM_TX, INPUT);
    }
    
    if (digitalRead(Y_AXIS_M))
    {
        //Y-
        pinMode(COM_TX, OUTPUT);
        Serial.print(YM);
        Serial.flush();
        pinMode(COM_TX, INPUT);
    }
    
    if (digitalRead(Z_AXIS_P))
    {
        //Z+
        pinMode(COM_TX, OUTPUT);
        Serial.print(ZP);
        Serial.flush();
        pinMode(COM_TX, INPUT);
    }
    
    if (digitalRead(Z_AXIS_M))
    {
        //Z-
        pinMode(COM_TX, OUTPUT);
        Serial.print(ZM);
        Serial.flush();
        pinMode(COM_TX, INPUT);
    }

    delay(200); //debounce delay
}
